<?php
define('PATH_DATA',"/usr/local/esiaCollector/flows/data");
define('PATH_RRD',"/usr/local/esiaCollector/flows/data");
define('PATH_NFDUMP',"/usr/bin/nfdump");
function getNfdumpStatistic($channel,$dir)
{
	if(is_dir(PATH_DATA."/$channel/$dir"))
	{
		$exec = PATH_NFDUMP." -I -R ".PATH_DATA."/$channel/$dir";
		//echo "$exec\n";
		exec($exec,$output,$ret);
		if($ret == 250)
		{
			return null;
		}
		$final_array = array();
		foreach($output as $line)
		{
			$tmp = explode(':',$line);
			$key = trim($tmp[0]);
			$val = trim($tmp[1]);
			$final_array[$key] = $val;
		}
		return $final_array;
	}
	else
	{
		return null;
	}
}
function getNfdumpTopPort($channel,$start,$end,$type,$top=10,$subfilter='')
{
    $startrepertoire = date('Y/m/d',$start);
    $startfile = getStartEndFile($start);
    $endrepertoire = date('Y/m/d',$end);
    $endfile = getStartEndFile($end);

    //Trace("Type $type",$DEBUG);
    $filter = '';
    $outputType='base';
    switch($type)
    {
        case 'port':		$filter='-A proto,dstport -O bytes'; break;
        default: $filter = '-A srcip,srcport,dstip,dstport -O bytes'; break;
    }
    if(!empty($subfilter))
    {
        $subfilter="'$subfilter'";
    }
    //vérifier si le fichier start exist sinon prendre le plus réçent
    $startpathfile="$startrepertoire/nfcapd.$startfile";
    $exec = PATH_NFDUMP." -M ".PATH_DATA."/".$channel." -T -R $startpathfile:$endrepertoire/nfcapd.$endfile $filter -n $top -o csv $subfilter";
    //

    //echo "$exec\n";
    //Trace("EXEC : $exec",1);
    exec($exec,$output,$ret);
    if($ret == 250)
    {
    	return null;
    	//erreur fichier non trouvé car pas de donnée disponnible pour le canal spécifier.
		//TO DO A TRAITER
		//$exec = PATH_NFDUMP." -M ".PATH_DATA."/".$channel." -T -R $startpathfile:$endrepertoire/nfcapd.$endfile $filter -n $top -o csv $subfilter";
		//exec($exec,$output,$ret);
    }
    //Trace($output,1);
  	$final_array = formatExtendPortOutput($output);

    return $final_array;
}
function getNfdumpData($channel,$start,$end,$type,$top=10,$subfilter='')
{
    $startrepertoire = date('Y/m/d',$start);
    $startfile = getStartEndFile($start);
    $endrepertoire = date('Y/m/d',$end);
    $endfile = getStartEndFile($end);
    //Trace("Type $type",$DEBUG);
    $filter = '';
    $outputType='base';
    switch($type)
    {
        case 'ip-port':             $filter='-A srcip,dstip,dstport -O bytes'; break;
        case 'ip-flows':            $filter="-s ip/flows"; break;
        case 'ip-bytes':            $filter="-s ip/bytes"; break;
        case 'ip-bytes-dst':        $filter="-s dstip/ibyte"; break;
        case 'ip-bytes-src':        $filter="-s srcip/ibyte"; break;
        case 'ip-bytes-download':   $filter="-a -A srcip,dstip -O ibyte"; $outputType='extend'; break;
        case 'ip-bytes-upload':     $filter="-a -A dstip,srcip -O ibyte"; $outputType='extend'; break;
        case 'port-flows':          $filter="-s port/flows"; break;
        case 'port-bytes':          $filter="-s port/bytes"; break;
        default: $filter = '-A srcip,srcport,dstip,dstport -O bytes'; break;
    }
    if(!empty($subfilter))
    {
        $subfilter="'$subfilter'";
    }
    //vérifier si le fichier start exist sinon prendre le plus réçent
    $startpathfile="$startrepertoire/nfcapd.$startfile";
    $exec = PATH_NFDUMP." -M ".PATH_DATA."/".$channel." -T -R $startpathfile:$endrepertoire/nfcapd.$endfile $filter -n $top -o csv $subfilter";
    //

    //echo "$exec\n";
    //Trace("EXEC : $exec",1);
    exec($exec,$output,$ret);
    if($ret == 250)
    {
    	return null;
    	//erreur fichier non trouvé car pas de donnée disponnible pour le canal spécifier.
		//TO DO A TRAITER
		//$exec = PATH_NFDUMP." -M ".PATH_DATA."/".$channel." -T -R $startpathfile:$endrepertoire/nfcapd.$endfile $filter -n $top -o csv $subfilter";
		//exec($exec,$output,$ret);
    }
    //Trace($header,1);
    $final_array = array();
   // Trace("EXEC : $outputType",1);
    if($outputType=='base')
    {
    	$final_array = formatBaseOutput($output);
    }
    else
    {
  		$final_array = formatExtendOutput($output);
    }
    return $final_array;
}
function getStartEndFile($date)
{
    $startfile = date('YmdH',$date);
    $minute = date('i',$date);
    $m = ($minute%5);
    if($m != 0)
    {
    	$t = $minute - $m;
    	if($t < 10)
    	{
    	    $minute= '0'.$t;
    	}
    	else
    	{
    		$minute= $t;
    	}
    }
    $startfile.=$minute;
    return $startfile;
}
function formatBaseOutput($output)
{
    $final_array = array();
    $header = array_shift($output);
    $header = explode(',',$header);
    foreach($output as $line)
    {
        //trace("$line");
        if(!empty($line))
        {
            if(strpos($line,'Summary')===false)
            {
                $line = explode(',',$line);
                $arr = array();
                foreach($header as $i => $cel)
                {
                    $arr[$cel] = $line[$i];
                }
                $final_array[]=$arr;
            }
            else
		    {
		        break;
		    }
        }
        else
        {
            break;
        }
    }
    return $final_array;
}
function formatExtendOutput($output)
{
    $final_array = array();
    $header = array_shift($output);
    $header = explode(',',$header);
    foreach($output as $line)
    {
        if(!empty($line))
        {
            if(strpos($line,'Summary')===false)
            {
				$line = explode(',',$line);
				//print_r($line);
				if($line[3] == 'avg_bps' && $line[4] == 'avg_pps')
				{
					break;
				}
				else
				{
				    $arr = array();
				    foreach($header as $i => $cel)
				    {
						$arr[$cel] = $line[$i];
					}
					$final_array[]=$arr;
				}
			}
		    else
		    {
		        break;
		    }
        }
        else
        {
            break;
        }
    }
    //exit(1);
    return $final_array;
}
function formatExtendPortOutput($output)
{
    $final_array = array();
    $header = array_shift($output);
    $header = array(6=>'dp',7=>'pro',11=>'ipkt',12=>'ibyt');
    foreach($output as $line)
    {
        if(!empty($line))
        {
            if(strpos($line,'Summary')===false)
            {
				$line = explode(',',$line);
				//print_r($line);
				if($line[3] == 'avg_bps' && $line[4] == 'avg_pps')
				{
					break;
				}
				else
				{
				    $arr = array();
				    foreach($header as $i => $cel)
				    {
						$arr[$cel] = $line[$i];
					}
					$final_array[]=$arr;
				}
			}
		    else
		    {
		        break;
		    }
        }
        else
        {
            break;
        }
    }
    //exit(1);
    return $final_array;
}
?>
