#!/usr/bin/php
<?php
include_once '/usr/local/esiaCollector/plugins/utils.php';
include_once '/usr/local/esiaCollector/plugins/nfdump.libs.php';
include_once '/usr/local/esia/plugins/lib/CacheFile.class.php';
$CACHEDIRECTORY='/tmp/flows-stats/';
if( is_dir($CACHEDIRECTORY) == FALSE)
{
    if(mkdir($CACHEDIRECTORY,0755)==FALSE)
    {
        echo "Can't create direcotry cache\n";
        exit(3);
    }
}

$action='stats';
$DEBUG = 0;

$SHORT_OPTS="c:t:n:s:e:hdI:i:";
$LONG_OPTS=array("channel:","type:","number:","help","start:","end:","debug","IP:","interval:");
$type = 'ip-bytes';
$options = getopt($SHORT_OPTS, $LONG_OPTS);
$channel = getParam($options,'c','channel');
$type = getParam($options,'t','type','ip-bytes');
$top = getParam($options,'n','number',10);
$start = getParam($options,'s','start');
$end = getParam($options,'e','end');
$filterIP = getParam($options,'I','IP');
$interval = getParam($options,'i','interval');
$DEBUG = getParam($options,'d','debug');
if(empty($channel))
{
    echo "channel is empty\n";
    exit(1);
}
if(!empty($interval))
{
	$interval = $interval * 60;
	$date = new DateTime();
	$end = $date->getTimestamp();
	$start= $end - $interval;
}

$subfilter='';
//Préparation du fichier de cache
$arr=array();
$datatype = 'ip-bytes';
switch($type)
{
	case 'ip-traffic':$datatype = 'ip-bytes'; break;
	case 'ip-bytes':
	case 'ip-bytes-public':
	case 'ip-bytes-lan': $datatype = 'ip-bytes'; break;
	case 'ip-bytes-download':
	case 'ip-bytes-public-download':
	case 'ip-bytes-lan-download': $datatype = 'ip-bytes-download'; break;
	case 'ip-bytes-upload':
	case 'ip-bytes-public-upload':
	case 'ip-bytes-lan-upload': $datatype = 'ip-bytes-upload'; break;
	default: echo 'bad selected type'; exit(3);
}
if(!empty($filterIP))
{
    if(strpos($type,'download')!==false)
    {
        $subfilter = "src ip $filterIP";
    }
    elseif(strpos($type,'upload')!==false)
    {
        $subfilter = "dst ip $filterIP";
    }
    else
    {
        $subfilter = "ip $filterIP";
    }
}
// préparation du fichier de cache
$filename = $channel.'_'.$datatype.'_'.$interval.$subfilter.'.txt';
$filename = preg_replace('#\s+#','_',$filename);
Trace("CACHE_FILE: PREPARE $filename",$DEBUG);
$cacheduring =getCacheDuring($interval,5);
$file = new CacheFile($CACHEDIRECTORY.$filename,$cacheduring,true);
$data=array();
if($file->isValid())
{
	Trace("CACHE_FILE: VALID",$DEBUG);
	$data = $file->getData();
}
else
{
	Trace("CACHE_FILE: NO VALID",$DEBUG);
	Trace("NFDUMP DATA $subfilter",$DEBUG);
	$data = getNfdumpData($channel,$start,$end,$datatype,10000,$subfilter);
	if(!empty($data))
	{
		$file->writeData($data);
	}
}
$filter ='all';
if(strpos($type,'public')!==false)
{
	$filter = 'public';
}
elseif(strpos($type,'lan')!==false)
{
	$filter = 'lan';
}
$subfilter ='all';
if(strpos($type,'download')!==false || strpos($type,'upload')!==false)
{
	$iparr = array();
	Trace("TREAT IP",$DEBUG);
	if(strpos($type,'download')!==false)
	{
		$iparr = treatTopIpflows($data,$filter,'da');
	}
	else
	{
		$iparr = treatTopIpflows($data,$filter,'sa');
	}
	Trace($iparr,$DEBUG);
	$i=0;
	foreach($iparr as $line)
	{
		$hostname = gethostbyaddr($line['ip']);
		$line['hostname']=$hostname;
		$arr[]=$line;
		$i++;
		if($i >= $top)
		{
			break;
		}
	}
}
else
{
	//Trace($data,$DEBUG);
	$i=0;
	foreach($data as $line)
	{
		//echo print_r($line,true);
		$ip='';
		$ip = $line['val'];
		$flag = false;
		if($filter == 'public')
		{
			if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE))
			{
				$flag = true;
			}
		}
		elseif($filter == 'lan')
		{
			if (!filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE))
			{
				$flag = true;
			}
		}
		elseif($filter == 'all')
		{
			$flag = true;
		}
		if ($flag == true)
		{
			$hostname = gethostbyaddr($ip);
			$arr[] = array('ip'=>$line['val'],'hostname'=>$hostname,'ibyt'=>$line['ibyt'],'ibytP'=>$line['ibytP'],'ipkt'=>$line['ipkt']);
			$i++;
			if($i >= $top)
			{
				break;
			}
		}
	}
}
Trace($arr,$DEBUG);
$text = json_encode($arr);
$text =iconv("UTF-8", "CP437", $text);
iconv_set_encoding('output',"CP437");
echo $text;
function treatTopIpflows($data,$filter,$key)
{
	$subfilter = 'download';
	$ip_array = array();
	if($filter == 'public')
	{
		foreach($data as $line)
		{
			$ip = $line[$key];
			if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE))
			{
				if(array_key_exists($ip,$ip_array))
				{
					$ip_array[$ip]['ibyt'] += $line['ibyt'];
				}
				else
				{
					$ip_array[$ip] = array('ip'=>$ip,'hostname'=>$ip,'ibyt'=>$line['ibyt']);
				}
			}
		}
	}
	else
	{
		foreach($data as $line)
		{
			$ip = $line[$key];
			if (!filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE))
			{
				if(array_key_exists($ip,$ip_array))
				{
					$ip_array[$ip]['ibyt'] += $line['ibyt'];
				}
				else
				{
					$ip_array[$ip] = array('ip'=>$ip,'hostname'=>$ip,'ibyt'=>$line['ibyt']);
				}
			}
		}
	}
	uasort($ip_array, 'sortIPByte');
	return $ip_array;
}
function sortIPByte($a, $b)
{
	if($a['ibyt'] < $b['ibyt'])
	{
		return 1;
	}
	else
	{
		return -1;
	}
}
?>
