#!/usr/bin/php
<?php
include_once '/usr/local/esiaCollector/plugins/utils.php';
include_once '/usr/local/esiaCollector/plugins/nfdump.libs.php';
include_once '/usr/local/esia/plugins/lib/CacheFile.class.php';
$CACHEDIRECTORY='/tmp/flows-stats/';
if( is_dir($CACHEDIRECTORY) == FALSE)
{
    if(mkdir($CACHEDIRECTORY,0755)==FALSE)
    {
        echo "Can't create direcotry cache\n";
        exit(3);
    }
}

$action='stats';
$DEBUG = 0;

$SHORT_OPTS="c:t:n:s:e:hdSDi:I:";
$LONG_OPTS=array("channel:","type:","number:","help","start:","end:","debug","src:","dest:","interval:","IP:");
$type = 'ip-bytes';
$options = getopt($SHORT_OPTS, $LONG_OPTS);
$channel = getParam($options,'c','channel');
$type = getParam($options,'t','type','ip-bytes');
$top = getParam($options,'n','number',10);
$start = getParam($options,'s','start');
$end = getParam($options,'e','end');
$interval = getParam($options,'i','interval');
$filterIP = getParam($options,'I','IP');
$DEBUG = getParam($options,'d','debug');
if(empty($channel))
{
    echo "channel is empty\n";
    exit(1);
}
if(!empty($interval))
{
	$interval = $interval * 60;
	$date = new DateTime();
	$end = $date->getTimestamp();
	$start= $end - $interval;
}

$subfilter='';
//Préparation du fichier de cache
$arr=array();
$datatype = 'port';
switch($type)
{
	case 'port':$datatype = 'port'; break;

	default: echo 'bad selected type'; exit(3);
}
if(!empty($filterIP))
{
    if(strpos($type,'download')!==false)
    {
        $subfilter = "dst ip $filterIP";
    }
    elseif(strpos($type,'upload')!==false)
    {
        $subfilter = "src ip $filterIP";
    }
    else
    {
        $subfilter = "ip $filterIP";
    }
}

// préparation du fichier de cache
$filename = $channel.'_'.$datatype.'_'.$interval.$subfilter.'.txt';
$filename = preg_replace('#\s+#','_',$filename);
Trace("CACHE_FILE: PREPARE $filename",$DEBUG);
$cacheduring =getCacheDuring($interval,5);
$file = new CacheFile($CACHEDIRECTORY.$filename,$cacheduring,true);
$data=array();
if($file->isValid())
{
	Trace("CACHE_FILE: VALID",$DEBUG);
	$data = $file->getData();
}
else
{
	Trace("CACHE_FILE: NO VALID",$DEBUG);
	$data = getNfdumpTopPort($channel,$start,$end,$datatype,10000,$subfilter);
	if(!empty($data))
	{
		$file->writeData($data);
	}
}

	$i=0;
foreach($data as $line)
{
	$arr[]=$line;
	$i++;
	if($i >= $top)
	{
		break;
	}
}
Trace($arr,$DEBUG);
$text = json_encode($arr);
$text =iconv("UTF-8", "CP437", $text);
iconv_set_encoding('output',"CP437");
echo $text;

?>
